extends VBoxContainer
##A chat client for sending messages. Not sure if I also want to use this as a in-game debug menu.

func toggle_vis():
	if(!visible):
		visible = true
		Input.set_mouse_mode(Input.MOUSE_MODE_VISIBLE)
	else:
		visible = false
		Input.set_mouse_mode(Input.MOUSE_MODE_CAPTURED)
		send_message(get_tree().get_network_unique_id(),get_node("c_ui/c").text)

func send_message(id,value):
	if(value != ""):
		get_node("log").append_bbcode((str(id)+": "+value+"\n"))
	get_node("c_ui/c").text = ""

func _on_send():
	send_message(get_tree().get_network_unique_id(),get_node("c_ui/c").text)

func _input(event):
	if(event.is_action_pressed("ui_chat")):
		toggle_vis()

func _ready():
	get_node("c_ui/but_send").connect("pressed",self,"_on_send")