extends "res://scripts/projectile.gd"
##A ray cast that does damage to units, decoys, and mechas
export(float) var growdis = 2.05
func _process(delta):
	#Grow the ray as time goes on
	var ray = get_node("area/ray")
	var dray = ray.shape
	if(dray.is_class("RayShape")):
		dray.length += growdis #ray can't have negative length

func _ready():
	var area = Area.new()
	var ray = CollisionShape.new()
	var dray = RayShape.new()
	dray.length = 0
	ray.shape = dray
	ray.name = "ray"
	area.name = "area"
	area.add_child(ray)
	add_child(area)