extends "res://scripts/hitscan.gd"
###A Visible ray cast
func draw_line(endpoint = Vector3(3,3,3)):
	var vis = get_node("vis")
	vis.clear()
	vis.begin(Mesh.PRIMITIVE_POINTS, null)
	vis.add_vertex(global_transform.origin)
	vis.add_vertex(endpoint)
	vis.end()

func _ready():
	var vis = ImmediateGeometry.new()
	vis.name = "vis"
	var mat = SpatialMaterial.new()
	mat.flags_unshaded = true
	mat.flags_use_point_size = true
	mat.albedo_color = Color("ff00ff")
	vis.material_override = mat
	add_child(vis)