extends VBoxContainer

func draw_dots_of(pnode,legend,dotsize = 2 ,mapscale = 2,offset = Vector2(0,55)):
		if(has_node(pnode)):
			var hq = get_node(pnode)
			for h in hq.get_children():
				var pos = ((Vector2(h.global_transform.origin.z,h.global_transform.origin.x)/mapscale)+offset)
				draw_circle(pos,dotsize,legend[h.faction])

func _draw():
	#Draws the map
	var legend = [	Color("ffffff"),#A legend key for the colors of each object
					Color("0000ff"),
					Color("ff0000")] 

	if(has_node("/root/level")):
		var level = get_node("/root/level")
		draw_dots_of("/root/level/hq",legend,9)
		draw_dots_of("/root/level/bases",legend,6)
		draw_dots_of("/root/level/units",legend)

func _process(delta):
	update()

func _ready():
	pass
