"""Remember since this node is input_con it control's it's parent"""

extends "res://scripts/input_con.gd"
###The player input handler for mecha.gd

#Command
var control_type = 1
var playcon = playern#For input purposes this must be seprated. Online games will be funny otherwise.
var is_commanding = false
var is_buying = false
var is_other = false
#Control
var con_dir = Vector2()#This isn't used for mouse, needs a better mehtod 
#Mecha keywords
var pin
var unit_list
var inventory
var units_pickupable

var sensitivity = ProjectSettings.get("Game/Options/Sensitivity")

##Monitoring
func display_hint(value = "",altvalue = ""):
	if is_other:
		get_tree().call_group("player_ui"+str(playern),"display_hint",altvalue)
	else:
		get_tree().call_group("player_ui"+str(playern),"display_hint",value)

##Command
func command_handler():
	var one = Input.is_action_just_pressed(str(playcon)+"one")
	var two = Input.is_action_just_pressed(str(playcon)+"two")
	var three = Input.is_action_just_pressed(str(playcon)+"three")
	var four = Input.is_action_just_pressed(str(playcon)+"four")
	
	var tre = get_tree()
	if is_other:
		if one:
			p.command_selected(4)
		elif two || three || four:
			p.command_selected(0)
	else:
		if one:
			p.command_selected(2)
		elif two:
			p.command_selected(3)
		elif three:
			p.command_selected(5)
		elif four:
			p.command_selected(6)

func buy_handler():
	var one = Input.is_action_just_pressed(str(playcon)+"one")
	var two = Input.is_action_just_pressed(str(playcon)+"two")
	var three = Input.is_action_just_pressed(str(playcon)+"three")
	var four = Input.is_action_just_pressed(str(playcon)+"four")

	if is_other:
		if one:
			p.buy_a_unit(0)
		elif two:
			p.buy_a_unit(1)
		elif three:
			p.buy_a_unit(2)
		elif four:
			p.buy_a_unit(3)
	else:
		if one:
			p.buy_a_unit(4)
		elif two:
			p.buy_a_unit(5)
		elif three:
			p.buy_a_unit(6)
		elif four:
			p.buy_a_unit(7)

##Movement
func create_rect():
	var rect = Position3D.new()
	var mesh = MeshInstance.new()
	var shape = CubeMesh.new()
	var mat = load("res://assets/materials/simple_test_red.tres")
	shape.size = Vector3(0.8,0.8,0.8)
	mesh.mesh = shape
	rect.name = "recticle"
	rect.add_child(mesh)

	rect.set_network_master(get_network_master())#I have no idea what is up with the recticle.

	p.add_child(rect)

	mesh.set_surface_material(0,mat)#Sets the material after spawn

func rot_pin_mou(relative):# Rotates the mesh too This is for mouse
	#print("player.gd",relative)

	move_rect(relative*sensitivity)

	var rectcord = Vector3(p.get_node("recticle").global_transform.origin.x,pin.global_transform.origin.y,p.get_node("recticle").global_transform.origin.z)
	pin.look_at(rectcord,Vector3(0,1,0))

func rot_pin_con(direction): # Rotates the mesh too This is for Controler
	#Okay so the control menu does not change this for player one. Player one always has the rot_pin_mou. For somereasom?
	p.get_node("recticle").translation = Vector3(direction.x,p.get_node("recticle").translation.y,direction.y)

	var rectcord = Vector3(p.get_node("recticle").global_transform.origin.x,pin.global_transform.origin.y,p.get_node("recticle").global_transform.origin.z)
	if pin.global_transform.origin != rectcord:
		pin.look_at(rectcord,Vector3(0,1,0))

func move_rect(relative):#Moves the recticle which displays where a shot will go.
	#As of Godot 3.1 Getting the mouse pos then linking it to the viewport will not work as mousepos is constantly locked to the middle of the viewport

	p.get_node("recticle").translation.x += relative.x
	p.get_node("recticle").translation.z += relative.y

##Main
func _input(event):
	if(event.is_class("InputEventMouseMotion")):
		if(control_type == 0): #0 = Mouse
			rot_pin_mou(event.relative)
	
	if event.is_class("InputEventMouseButton") || event.is_class("InputEventKey") || event.is_class("InputEventJoypadMotion") || event.is_class("InputEventJoypadButton"):
		if event.is_action_pressed(str(playcon)+"charl"):
			p.vel.x = -1
		elif event.is_action_pressed(str(playcon)+"charr"):
			p.vel.x = 1
		elif (event.is_action_released(str(playcon)+"charl") && p.vel.x == -1) || (event.is_action_released(str(playcon)+"charr") && p.vel.x == 1):
			p.vel.x = 0
		if event.is_action_pressed(str(playcon)+"charu"):
			p.vel.z = -1
		elif event.is_action_pressed(str(playcon)+"chard"):
			p.vel.z = 1
		elif (event.is_action_released(str(playcon)+"charu") && p.vel.z == -1) || (event.is_action_released(str(playcon)+"chard") && p.vel.z == 1):
			p.vel.z = 0
			
		if(control_type != 0): #1 = Control stick/Keypad
			if event.is_action_pressed(str(playcon)+"aiml"):
				con_dir.x = -3
			elif event.is_action_pressed(str(playcon)+"aimr"):
				con_dir.x = 3
			elif (event.is_action_released(str(playcon)+"aiml") && con_dir.x == -3) || (event.is_action_released(str(playcon)+"aimr") && con_dir.x == 3):
				con_dir.x = 0
			if event.is_action_pressed(str(playcon)+"aimd"):
				con_dir.y = 3
			elif event.is_action_pressed(str(playcon)+"aimu"):
				con_dir.y = -3
			elif (event.is_action_released(str(playcon)+"aimd") && con_dir.y == -3) || (event.is_action_released(str(playcon)+"aimu") && con_dir.y == 3):
				con_dir.y = 0
			rot_pin_con(con_dir)
		
		if event.is_action_pressed(str(playcon)+"fly"):
			if(!p.is_over_base || p.is_over_land):
				if(p.inventory.size() > 0):
					p.drop_unit(inventory[0])
					p.inventory.remove(0)
				else:
					p.toggle_flight()

		if event.is_action_pressed(str(playcon)+"firep"):#NETWORK ISSUE: This is activating on both client's screens
			p.are_guns_firing[0] = 1
		elif event.is_action_released(str(playcon)+"firep"):
			p.are_guns_firing[0] = 0
		if event.is_action_pressed(str(playcon)+"fires"):
			p.are_guns_firing[1] = 1
		elif event.is_action_released(str(playcon)+"fires"):
			p.are_guns_firing[1] = 0
		if event.is_action_pressed(str(playcon)+"decoy"):
			if p.is_flying:
				p.are_guns_firing[2] = 1
		elif event.is_action_released(str(playcon)+"decoy"):
			p.are_guns_firing[2] = 0

		if event.is_action_pressed(str(playcon)+"buy"):
			is_buying = true
			display_hint('1/up='+unit_list[4][3]+' \n 2/down='+unit_list[5][3]+' \n 3/left='+unit_list[6][3]+' \n 4/right='+unit_list[7][3],'1/up='+unit_list[0][3]+' \n 2/down='+unit_list[1][3]+' \n 3/left='+unit_list[2][3]+' \n 4/right='+unit_list[3][3])
		elif event.is_action_released(str(playcon)+"buy"):
			is_buying = false
			display_hint()
		if event.is_action_pressed(str(playcon)+"pickup"):
			if(p.is_flying):
				if(p.is_over_base):
					if(p.mecha_unit_ready_list.size() > 0 && (p.inventory.size() < 5)):
						p.pickup_unit(p.mecha_unit_ready_list[0])
						p.pickup_ready_unit()
				elif(p.units_pickupable.size() > 0):
					for unit_i in p.units_pickupable:
						p.pickup_unit(unit_i.get_filename())
						unit_i.queue_free()
					p.units_pickupable = []
		if(event.is_action_pressed(str(playcon)+"command")):
			is_commanding = true
			display_hint('1/up=defend \n 2/down=seek \n 3/left=attack \n 4/right=destroy','1/up=follow \n ELSE=Patrol')
		elif(event.is_action_released(str(playcon)+"command")):
			is_commanding = false
			display_hint()

		if event.is_action_pressed(str(playcon)+"other"):
			is_other = true
		elif event.is_action_released(str(playcon)+"other"):
			is_other = false

		if(event.is_action_pressed(str(playcon)+"disshop")):#Display the shop.
			get_tree().call_group("player_ui"+str(p.trackingn),"toggle_shop")

##MAIN
func _physics_process(delta):
	if is_buying:
		buy_handler()
	if is_commanding:
		command_handler()

func _ready():
	pin = p.get_node("pin")
	unit_list = p.unit_list
	inventory = p.inventory
	units_pickupable = p.units_pickupable

	if(get_tree().network_peer == null || (get_tree().get_network_unique_id() == get_network_master())):# If the scene is local/ it's own client create then create a recticle to aim.
		create_rect()#This creates the recticle for aiming

	get_tree().call_group(str(playern)+"vcon","set_camsock",p.get_node("camsocket"))

	#if online set the controls to player 1, 
	if(get_tree().has_network_peer()):
		playcon = 0
		if(!is_network_master()):#If netplay this should only have input for it's own client
			set_process_input(false)
	#I may change this later so that more than one player from one computer can connect to a match.
	else:#For some reason playern at start will be null value. this ensures the playcon gets the right number for local play. 
		playcon = playern

	if(has_node("/root/hud")):#Change the recticle control type
		control_type = get_node("/root/hud").player_control_type[playcon]