extends RigidBody
###A Projectile for 
var multiplier = ProjectSettings.get("Game/Fun/multiplier")
#Description
var gname = "projectile"
var playern = 1 #What player owns the projectile
var faction = 1
#Timer
var time = 0.6
#Status
export var speed = 2
var delaydeath = 1 
export var damage = 10

func _on_area_area_enter( area ):
	var parea = area.get_parent()
	if(parea.is_in_group("projectile") || (area.collision_layer == 1025)):
		if parea.playern != playern:
			queue_free() #Deletes projectile when entered an enemy object colision

func _physics_process(delta):
	time = time - delta
	if time < 0:
		queue_free()

func projectile_multiplier():#Multiplies the variables if the multiplier is active
	var multiplier = ProjectSettings.get("Game/Fun/multiplier")
	
	speed = speed * multiplier
	damage = damage * multiplier

func _ready():
	add_to_group(gname)
	set_process(true)
	connect("body_entered",self,"_on_area_area_enter")

	projectile_multiplier()