extends "res://scripts/AI_mecha_entity.gd"
#Cpu player AI that's a little quirky in the head.

#func _ready():#TEMP, this script should never have a ready function
#	p.money = 2001 #This is for testing turrent mode

#0 = mimic/ standard infantry
#1 = bazooka / Anti air infantry
#2 = jeep / light vehical
#3 = tank / Heavy vehical
#4 = motorbike / Fast infantry
#5 = antiair / Anit air infantry
#6 = turrent / Stationary defense
#7 = airplane / Air support

##MAIN
func ai_handler(delta):
#	print("Stupid AI: ","Mode:[",current_mode,"]",current_state,"---",current_step,current_base," $",p.money)
#	print("Stupid AI: ",current_step,"OOO",wait_timer,"___")#," Inv:",p.mecha_unit_ready_list)#HUH? it refuses to go out side it's own base?
	match(current_mode):
		(game_modes.DB):#Destroy base
			if(p.money >= 9000):#If at anytime this limit is reached.
				set_ai_behavior(AI_State.BUILD)
			match(current_state):#The AI state
				(AI_State.BUILD):#Currently building units
					match(current_step):
						(0):#1. check funds 
							if(!p.is_flying):#if it is not flying already
								p.toggle_flight()
							if(p.money >= 9000):#Swimming in cash just march to the hq
								var strat = [5,3,4,7,3,4,1,1,1,1]
								create_units(strat,1)
								set_ai_behavior(AI_State.DESTROY)
							elif((p.money >= 5000) && (p.money < 9000)):#Go for the base
								var strat = [5,4,3,0,0,0,0,2]
								create_units(strat,2)
								set_ai_behavior(AI_State.ATTACK)
							elif((p.money >= 2000) && (p.money < 5000)):#Assit a teammate/defense
								#check if has any teammates
								var currentselectedplayer = 0
								create_units([0,2],1)
								for mech in hud.players_active:
									if((mech == faction)&&(currentselectedplayer != playern)):#Make sure the mech isn't the AI's own mech.
										set_ai_behavior(AI_State.FOLLOW)
										break
									else:#If there is none then just find a weak point to destroy.
										set_ai_behavior(AI_State.TURRENT)

									currentselectedplayer += 1

							elif((p.money >= 1000) && (p.money < 2000)):#Strengthen the base defense
								var strat = [5,2,2]
								create_units(strat,0)
								set_ai_behavior(AI_State.DEFEND)
							else:#There are no/low funds
								set_ai_behavior(AI_State.HUNT)#Kill some time by eliminating a player
						_:#The ai step has gone over bound
							current_step = 0
				(AI_State.TURRENT):#Currently trying to hold a position.
				#When you think yourself as worthless Remember that you are crowned with glory over God's creation
				#With the angels being the only thing more than you. If only by a little. It is written in Pslams 8:3-5
					match(current_step):
						(0):#Wait for light assult 
							wait_for_units(delta)
						(1):#Go get units for light assult
							get_current_base(0)
							current_step += 1
						(2):#Pick up units
							chase(current_base)
#							print("Stupid: ",current_base)
							if(p.is_over_base):
								stop()
								current_step += 1
						(3):# Find a place of turf worth fighting for
							find_unit(1)
							current_step += 1
						(4):#find that place and destroy the unit.
							if(is_instance_valid(objective)):
								chase(objective.global_transform.origin)
							else:
								current_step += 1
							if(p.are_guns_firing[0] == 1):#If the guns are firing that means it's range of attack
								while(p.inventory.size() > 0):#Drop off units 
									p.drop_unit(p.inventory[0])
									p.inventory.remove(0)
								p.toggle_flight()
								current_step += 1
						(5):#fight the unit till health is low or money is high.
							stop()
							if(p.health < 40):#Retreat!
								current_step += 1
							if(p.money > 4999):
								set_ai_behavior(AI_State.BUILD)
								p.toggle_flight()
						(6):#Retreat
							p.toggle_flight()
							get_current_base(0)
							current_step += 1
						(7):#Retreating to base
							chase(current_base)
#							print("Stupid: ",current_base)
							if(p.is_over_base):
								stop()
								current_step += 1
						(8):#When healed
							if((p.health > 90) && (p.money > 4999)):
								set_ai_behavior(AI_State.BUILD)
						_:#The ai step has gone over bound, head back to the build perameters.
							set_ai_behavior(AI_State.BUILD)
				(AI_State.DEFEND):#Defending a base/hq. This will automatically kick in if a base is under attack.
					match(current_step):
						0,9:# Should the AI help fight or let the units do all the work./ 9 = last loop
							wait_for_units(delta)
#							print("stupid:",p.mecha_unit_ready_list)
							if(p.health < 40):# If the mecha can not fight
								current_step = 6
						1,6,10:#Find a nearby base. / 6 = Retreat
							get_current_base(0)
							current_step += 1
						2,7,11:#HEAD TO THE BASE
							chase(current_base)
							if(p.is_over_base):
								stop()
#								if(has_node("/root/level/bases")):#Angle the drop spot, so the current_base faces towards the objective bases. 
#									var bases = get_node("/root/level/bases")
#									var targeted_base = find_base(bases,p.global_transform.origin.ceil(),1)
#									objective = direct_to(targeted_base,current_base)
								current_step += 1
						3,12:#Drop off the units
							find_drop_spot(current_base)#objective)
							if(p.money >= 2000):#If money has been overly obtained
								set_ai_behavior(AI_State.BUILD)
						4,13:#Stop this mecha
							stop()
							current_step += 1
						(5):
							if(p.money >= 2000):# Go to build.
								set_ai_behavior(AI_State.BUILD)
							elif(p.money >= 1000):#Bug better units
								create_units([6,1],1)
								current_step = 9
								drop_spot = null #Reset the drop spot..
							elif(p.money > 199):#Buy cheep units
								create_units([2],1)
								current_step = 0
							else:#Welp, switch modes nothing you can buy
								set_ai_behavior(AI_State.BUILD)
						(8):#End Retreat!
							if(p.health > 90):#Mecha is all patched up and ready to go.
								current_step = 0
						(14):#make sure no other enemy units are in the area.
							current_step += 1
						(15):#Wait till funds reach attack phase.
							if(p.money > 5000):
								set_ai_behavior(AI_State.BUILD)
						_:#The ai step has gone over bound, head back to the build perameters.
							set_ai_behavior(AI_State.BUILD)
				(AI_State.HUNT):#Picking off other players.
					match(current_step):
						(0):#1. check health
							if(p.health >= p.maxhealth):#Let's go
								current_step += 1
							else:#Otherwise head to a base to reheal
								get_current_base(0)
								current_step = 4
						(1):#2. Find the player
							if(get_tree().get_root().has_node("level/hq")):
								var hq = get_tree().get_root().get_node("level/hq")
								var enemyspawn = null
								for spawn in hq.get_children():
									if(spawn.faction != p.faction):
										enemyspawn = spawn
										break
								if(enemyspawn != null):
									var prev_player = null
									for player in enemyspawn.get_children():
										if((prev_player == null) || (prev_player.health > player.health)):#Go after the weakest mecha
											objective = player
											prev_player = player
									current_step += 1
								else:
									find_unit(1)
									current_step += 1
							else:#No player to be found but can go after a unit
								find_unit(1)
								current_step += 1
						(2):#3. Fight the player
							if(!is_instance_valid(objective)):#If the enemy is still alive
								chase(objective.global_transform.origin)
								if(p.health < 40):#if health is low, retreat.
									 current_step = 0
							else:#If the enemy is died then next step
								current_step += 1
						3,6:#4. determine what to do.
							if(p.money > 1225):#Hey we got funds to build units!
								set_ai_behavior(AI_State.BUILD)
							else:#still low on funds continue hunting
								current_step = 0
						(4):#Head to base to heal
							chase(current_base)
							if(p.is_over_base):
								stop()
								current_step += 1
						(5):#Wait till healed
							if(p.health >= (p.maxhealth - 10)):#Let's go
								current_step = 0
						_:#The ai step has gone over bound, head back to the build perameters.
							set_ai_behavior(AI_State.BUILD)
				(AI_State.FOLLOW):#Escorting another player
					match(current_step):
						(0):#1. Find a fellow faction
							if(get_tree().get_root().has_node("level/hq")):
								var hq = get_tree().get_root().get_node("level/hq")
								var allyspawn = null
								for spawn in hq.get_children():
									if(spawn.faction == p.faction):
										allyspawn = spawn
										break
								if(allyspawn != null):
									var prev_player = null
									for player in allyspawn.get_children():
										if((prev_player == null) || (prev_player.health > player.health)):#help the weakest mecha
											objective = player
											prev_player = player
									current_step += 1
							else:#Uh... i'm afraid there is no other players, just go to hunt
								set_ai_behavior(AI_State.HUNT)
						(1):#Oh boy! time for bro fisting and killing
							if(is_instance_valid(objective)):
								chase(objective.global_transform.origin) 
							else:
								current_step += 1
							if(p.health < 40):#Sorry mate I can't help ya no more
								get_current_base(0)
								current_step += 1
							elif(p.money > 1999):#Hey I got money, see ya mate!
								set_ai_behavior(AI_State.BUILD)
						(2):#RETREAT!
							chase(current_base)
							if(p.is_over_base):
								stop()
								current_step += 1
						(3):#determine next move
							if(p.health > (p.maxhealth - 10)):#I'm coming back bro!
								get_current_base(0)
								current_step += 1
							elif(p.money > 1999):#Hey I got money, see ya mate!
								set_ai_behavior(AI_State.BUILD)
						_:#The ai step has gone over bound, head back to the build perameters.
							set_ai_behavior(AI_State.BUILD)
				(AI_State.ATTACK):#Attack a base
					match(current_step):
						0,7:#Wait for units, in mean time find something to do.
							wait_for_units(delta)
						1,8:#Find a nearby base to pick up the units.
							get_current_base(0)
							current_step += 1
						2,9:#Go to the base.
							chase(current_base)
							if(p.is_over_base):
								stop()
								current_step += 1
						3,10:#Drop off the units
							find_drop_spot()
						4,11:#Stop this mecha
							stop()
							current_step += 1
						5,12:#Command the units to attack.
							p.command_selected(AI_State.ATTACK)
							current_step += 1
						(6):#Determine the next wave.
							if((p.money > 5000) && (p.money <= 7000)):#Aw yeah this is my kind of assult.
								create_units([3,3,2,0,0,0,0,1],1)#two tanks a jeep and a capture wave
								current_step = 0
							elif((p.money > 3000) && (p.money <= 5000)):# A standard attack.
								create_units([2,2,0,0,0,0,1],1)#two jeeps and a capture wave
								current_step = 0
							elif((p.money > 1000) && (p.money <= 3000)):#Harass wave, then find something else more productive, till funds return.
								create_units([0,1,2],1)#A trio of different infantry units.
								current_step = 7
							else: #Money is too much/To little
								set_ai_behavior(AI_State.BUILD)
						(13):#Alright time do something else.
							set_ai_behavior(AI_State.BUILD)
						_:#The ai step has gone over bound, head back to the build perameters.
							set_ai_behavior(AI_State.BUILD)
				(AI_State.DESTROY):#Go strait for the oppossing faction's base 
					match(current_step):
						(0):#prepare for the attack
							wait_for_units(delta)
						1:#Find a nearby base to pick up the units.
							get_current_base(0)
							current_step += 1
						2:#Go to the base.
							chase(current_base)
							if(p.is_over_base):
								stop()
								current_step += 1
						3:#Drop off the units
							find_drop_spot()
						4:#Stop this mecha
							stop()
							current_step += 1
						5:#Command the units to Destroy, and set the enemy hq as the objective
							p.command_selected(AI_State.DESTORY)
							if(get_tree().get_root().has_node("level/hq")):
								var hq = get_tree().get_root().get_node("level/hq")
								for spawn in hq.get_children():
									if(spawn.faction != p.faction):
										objective = spawn
										break
							current_step += 1
						6:#Charge!
							chase(objective.global_transform.origin)
							if(p.health < 40):#Retreat AHHHHHH!
								current_step += 1
							if(p.are_guns_firing[0] == 1):#Hey some resistance
								current_step += 3
								p.toggle_flight()
						7:#Retreat!
							chase(current_base)
							if(p.is_over_base):
								stop()
								current_step += 1
						(8):#Heal
							if(p.health > (p.maxhealth - 10)):#I'm coming back bro!
								current_step = 10
						9:#Fight!
							if(p.health < 40):#Retreat AHHHHHH!
								current_step = 7
						(10):#Alright time do something else.
							set_ai_behavior(AI_State.BUILD)
						_:#The ai step has gone over bound, head back to the build perameters.
							set_ai_behavior(AI_State.BUILD)
		(game_modes.ST):
			pass
		_:#The default is always DM
			match(current_state):
				_:#Default behavior
					match(current_step):
						(0):#Find the player.
							if(get_tree().get_root().has_node("level/hq")):
								var hq = get_tree().get_root().get_node("level/hq")
								var enemyspawn = null
								for spawn in hq.get_children():
									if(spawn.faction != p.faction):
										enemyspawn = spawn
										break
								if(enemyspawn != null):
									var prev_player = null
									for player in enemyspawn.get_children():
										if((prev_player == null) || (prev_player.health > player.health)):#Go after the weakest mecha
											objective = player
											prev_player = player
									current_step += 1
								else:
									find_unit(1)
									current_step += 1
						(1):#Chase the player
							if(p.are_guns_firing[0] == 1):#Hey we've made contact
								stop()
								if((!objective.is_flying && p.is_flying) || (objective.is_flying && !p.is_flying)):#If it's on land go on land, if it's in the air go to the air
									p.toggle_flight()
							else:#Hunt down the enemy
								if(is_instance_valid(objective)):
									chase(objective.global_transform.origin)
									if(!p.is_flying):#make sure chasing in the air for fastest speed
										p.toggle_flight()
						_:#Default action
							pass