"""Remember since this node is input_con it control's it's parent"""

extends "res://scripts/AI_mecha_entity.gd"

##Main
func ai_handler(delta):
	print("Decoy AI",current_base,target_enemy)
	if(objective != null):
		match(current_state):
			AI_State.DEFEND,AI_State.TURRENT:
				match(current_step):
					(0):
						stop()
						current_step += 1
					(1): 
						pass
			AI_State.HUNT,AI_State.ATTACK,AI_State.DESTROY:
				match(current_step):
					(0):
						if(target_enemy != null):
							current_step = 1
					(1): 
						if(is_instance_valid(target_enemy) && (ai_path.size() > 0)):
							var gtoc = p.global_transform.origin.ceil()
							create_path(target_enemy.global_transform.origin,gtoc)
							current_step += 1
						else:
							current_step = 0
					(2):
						if(ai_path.size() > 0):
							chase(ai_path[0])
						else:
							current_step = 1
			_:
				match(current_step):
					(0):
						p.toggle_flight()
						drop_spot == null
						get_current_base()
						current_step += 1
					(1):
						var gtoc = p.global_transform.origin.ceil()
						create_path(current_base,gtoc)
						current_step += 1
					(2):
						if(ai_path.size() > 0):
							chase(ai_path[0])
						else:
							current_step = 1
						if(p.is_over_base):
							stop()
							current_step += 1 
					(3):
						create_units(unit_waves['capture_base'],8)
					(4):
						wait_for_units(delta)
					(5):
						find_drop_spot()
					(6):
						p.toggle_flight()
						p.is_over_base = false

func _ready():
	#Add to decoy group
	p.trackingn = null
	p.remove_from_group(p.gname)
	pin.remove_from_group(p.name)
	p.toggle_flight()
	p.add_to_group(p.gname)
	pin.add_to_group(p.gname)
#Change all settings that would be for player/CPU player
	p.nickname[0] = p.nickname[0] + str(p.gname)
	p.decoy_timer = 0
	p.decoyammo = ""