"""THIS ENTIRE SYSTEM NEEDS REWORKED"""

extends "res://scripts/input_con.gd"
###The Base of AI scripts
#AI_handling
enum AI_State{
	BUILD,
	TURRENT,
	DEFEND,
	HUNT,
	FOLLOW,
	ATTACK,
	DESTROY}
var current_step = 0
var current_state = AI_State.DEFEND
#warning-ignore:unused_class_variable
var parent_player = null #Used for decoy and unit
#pathfinding
#warning-ignore:unused_class_variable
var objective = null
var current_base = Vector3()
var ai_path = PoolVector3Array([])#This should be changed to PoolVector3Array
var patrol_points = PoolVector3Array([Vector3(),Vector3()])#This should be changed to PoolVector3Array
#warning-ignore:unused_class_variable
var patrol_current = patrol_points[0]
#Mecha Keywords
var pin

#combat
var spotted_enemies = []
var target_enemy = null

##Monitoring
func create_command_indicator(): #Used for decoy and unit
	var sprite = Sprite3D.new()
	sprite.name = "com_ind"
	sprite.set_texture(load('res://assets/sprites/command_indicator.png'))
	sprite.rotation.x = 90
	sprite.scale = sprite.scale * 30
	sprite.visible = false
	p.add_child(sprite)

##Movement
func stop():
	p.vel = Vector3(0,0,0)

func aim(target):
	var target_no_y = Vector3(target.x,pin.global_transform.origin.y,target.z)
	pin.look_at(target_no_y,Vector3(0,1,0))

func chase(target):
	var tarx = Vector3(p.global_transform.origin.x,0,0).distance_to(Vector3(target.x,0,0))
	if(p.global_transform.origin.x < target.x):
		tarx = -tarx
	var tarz = Vector3(0,0,p.global_transform.origin.z).distance_to(Vector3(0,0,target.z))
	if(p.global_transform.origin.z < target.z):
		tarz = -tarz

	p.vel = (Vector3(-npz(tarx),p.vel.y,-npz(tarz)))

	if(target_enemy != null):
		if(typeof(weakref(target_enemy).get_ref()) != TYPE_NIL):
			aim(target)

func does_vceil_match(compare,tothis,int_range = 1):
	if((compare.x <= (tothis.x + int_range)) && (compare.x >= (tothis.x - int_range))):
		if((compare.z <= (tothis.z + int_range)) && (compare.z >= (tothis.z - int_range))):
			return true
	return false

##Pathfinding
func create_path(to, from):
	if(has_node("/root/level/nav")):
		var nav = get_node("/root/level/nav")
		var prev_point = from
		for point in nav.get_simple_path(from,to,true):
			var pceil = point.ceil()
			#If it's not that far from the last point then don't bother adding it in.
			if(!does_vceil_match(prev_point.ceil(),point.ceil())):
				ai_path.append(pceil)
				prev_point = pceil
	else:
		ai_path = [from,to]

func check_current_path():#Checks if the path route has been done.
	var gtoc = p.global_transform.origin.ceil()
	if(ai_path.size() > 0):
		if((gtoc.x) == ai_path[0].x):
			if((gtoc.z) == ai_path[0].z):
				if(ai_path.size() > 0):
					ai_path.remove(0)
				if(ai_path.size() <= 0):
					set_ai_behavior(current_state)

func find_closest_base(bases,gtoc,type = 2):#Finds the nearest base location
#This was originally find base, so if there is code that uses that, replace it with this.
	var tbdis = 999.0
	var c = Vector3()
	for i in bases:
		var bdis = gtoc.distance_to(i.global_transform.origin.ceil())
		if(bdis < tbdis):
			match(type):#type stands for type of base, is it friendly or is it neautral.
				0:#Friendly
					if(i.faction == p.faction):
						tbdis = bdis
						c = i.global_transform.origin.ceil()
				(1):#Uncapped and opposing faction
					if(i.faction != p.faction):
						tbdis = bdis
						c = i.global_transform.origin.ceil()
				_:#Does not care
					tbdis = bdis
					c = i.global_transform.origin.ceil()
	print("AI_entity.gd: find closest base, ",type,  " base is at - ",c)
	return c

func get_current_base(base_type):
	var gtoc = p.global_transform.origin.ceil()
	var bas = []
	if(has_node("/root/level/hq")):
		var hq = get_node("/root/level/hq")
		for i in hq.get_children():
			bas.append(i)
	if(has_node("/root/level/bases")):
		var bases = get_node("/root/level/bases")
		for j in bases.get_children():
			bas.append(j)
	current_base = find_closest_base(bas,gtoc,base_type)

func create_patrol():
	patrol_points.resize(0)
	if(current_base != null):
		if(has_node("/root/level/bases")):
			var bases = get_node("/root/level/bases")
			var c = find_closest_base(bases.get_children(),p.global_transform.origin.ceil())
			patrol_points.append(c)
			patrol_points.append(p.global_transform.origin.ceil())

##AI Handling
func npz(value,rangeof = 1):#Negative, Positive or zero (Only returns a whole 1 or 0)
	if(value > rangeof):
		return 1
	elif((value < 1) && (value > -1)):
		return 0
	else:
		return -rangeof

func set_ai_behavior(value):
	if(typeof(value) == TYPE_INT):
		current_state = value
		current_step = 0
	emit_signal("_on_state_change",[current_state])

## COMBAT
func create_scanner():
	var sensor = Spatial.new()#Makes this so base collision doesn't freak out over noneexisted grandparent
	var scanner = Area.new()
	var cshape = CollisionShape.new()
	var shape = SphereShape.new()
	shape.radius = 54
	cshape.shape = shape
	scanner.add_child(cshape)
	scanner.connect("area_entered",self,"_on_spot")
	scanner.connect("area_exited",self,"_on_unspot")
	sensor.add_child(scanner)
	p.add_child(sensor)

func get_next_enemy(impobject):
	spotted_enemies.remove(spotted_enemies.find(impobject))
	if(spotted_enemies.size() > 0):
		target_enemy = spotted_enemies[0]
	else:
		p.are_guns_firing[0] = 0
		p.are_guns_firing[1] = 0

func set_next_enemy(impobject):
	target_enemy = impobject
	spotted_enemies.append(impobject)
	if(p.are_guns_firing[0] != 1):
		p.are_guns_firing[0] = 1
		p.are_guns_firing[1] = 1

func enemy_toggled_flight(is_flying,impobject):#Flight was toggled by a unit_entity in the spot area.
	if((is_flying && p.is_flying) || (is_flying && (p.unitmode == p.unit_type.ANTI_AIR)) || (!is_flying && !p.is_flying)):#Don't attack the enemy unless it is on the same plane.
		set_next_enemy(impobject)
	else:
		get_next_enemy(impobject)
		

##COLID
func _on_spot(area):
	var parea = area.get_parent()
	var gparea = parea.get_parent()
	if((gparea.is_in_group("player")) || (gparea.is_in_group("decoy")) || (gparea.is_in_group("unit"))):
		if(gparea.faction != faction):#Friend or Foe?
			gparea.connect("_on_toggled_flight",self,"enemy_toggled_flight",[gparea])
			if((gparea.is_flying && p.is_flying) || (gparea.is_flying && (p.unitmode == p.unit_type.ANTI_AIR)) || (!gparea.is_flying && !p.is_flying)):#Don't attack the enemy unless it is on the same plane.
				set_next_enemy(gparea)

func _on_unspot(area):
	var parea = area.get_parent()
	var gparea = parea.get_parent()
	if((gparea.is_in_group("player")) || (gparea.is_in_group("decoy")) || (gparea.is_in_group("unit"))):
		if(gparea.faction != faction):
			gparea.disconnect("_on_toggled_flight",self,"enemy_toggled_flight")#Hey we don't need to track some one out of reach.
			if(target_enemy == gparea):#Hey the primary target is gone, let's change
				get_next_enemy(gparea)
			else:#Some smuck left, let's remove that from the hitlist.
				for te in spotted_enemies: 
					if(te == gparea):
						spotted_enemies.remove(spotted_enemies.find(te))

## MAIN
func _physics_process(delta):
#	print("CPU",current_step)
	call("ai_handler",delta)#This would not work in multiplayer. Get a better solution.
	check_current_path()

	if(target_enemy != null):
		if(is_instance_valid(target_enemy)):
#			print("CPU player",weakref(target_enemy).get_ref())
			aim(target_enemy.global_transform.origin)

func _ready():
	if(p.has_node("pin")):
		pin = p.get_node("pin")
	else:
		pin = p
	#Create a scanner
	create_scanner()

	add_user_signal("_on_state_change",[current_state])