extends Spatial
#Cutscenes and textboxes for tutorial.

export(Array, String) var dialogs = ["Hello world","This is the final dialog."]

enum objectives_list {MOVE,MONEY,CAPTURE,DESTROY,DEFEND,HUNT,BUILD}
#Move = an object where you must move to a point on the map.
#money = reach a limit of money 
#capture = capture a point/base
#defend = Defend a point, base, or unit
#hunt = Search and kill a unit or a group of units
#build = Build a number of a specific unit.
export(Array, objectives_list) var objectives = [objectives_list.MOVE]
var objective_goal = []
var objective_status = 0



##text popups
func cut(area,text,cur_cut,is_forced = false):#The next cutscene
	if(area.get_node("../..").is_in_group("player") || is_forced == true):
		get_tree().call_group("hud","dialogbox",text)

#Display the next cutscene, and remove the last one... To avoid overlap.
		var nex_cut = int(cur_cut.name) + 1
		if(has_node(str(nex_cut))):
			get_node(str(nex_cut)).visible = true
			get_node(str(nex_cut)).monitoring = true
			get_node(str(nex_cut)).monitorable = true
		if(has_node(str(cur_cut))):
			get_node(str(cur_cut)).visible = false
			get_node(str(cur_cut)).monitoring = false
			get_node(str(cur_cut)).monitorable = false

func _ready():
	if(get_child_count() == dialogs.size()-1):
		if(get_child_count() == objectives.size()):
			for i in get_children():
				if(i.is_class("Area")):
					i.connect("area_entered",self,"cut",[dialogs[int(i.name)+1],i])
					i.visible = false
					i.monitoring = false
					i.monitorable = false
			if(has_node("0")):
				var zero = get_node("0")
				zero.visible = true
				zero.monitoring = true
				zero.monitorable = true
				cut(zero,dialogs[0],zero,true)
		else:
			print("cutscenes.gd: ",get_parent().filename," does not have proper amount of objectives to areas")
	else:
		print("cutscenes.gd: ",get_parent().filename," does not have proper amount of dialogs ",dialogs.size()," to areas ",get_child_count()," (You must one more dialog than areas)")
