extends "res://scripts/base.gd"
###The main base if is destroyed the player who own's it, loses.
var hname = "headquarters"

export var is_cpu = false

var health = 2000

#Health monitoring
func die():
	get_tree().call_group("hud","set_victory",(faction - 2),true)

func set_health(value):
	health = health - value
	get_node("ui_hq_health/view/bar").set_value(health)
	if health < 0:
		die()

##Main
func _on_hq_colid(area):#This is made so not to interfer on the already established _on_colid in base.gd
	var parea = area.get_parent()
	if parea.is_in_group("projectile"):
		if parea.faction != faction:
			set_health(parea.damage)
			parea.queue_free()

func _ready():
	add_to_group(hname)
	add_to_group(hname+str(faction))

	is_capturable = false

	get_node("detect_bullets/areb").connect("area_entered",self,"_on_hq_colid")

	get_node("ui_hq_health/view/bar").set_max(health)
	get_node("ui_hq_health/view/bar").set_value(health)