extends Spatial
#A part with the ability to explode on death, guns recharge slowly
var value = []
var deduct = 3
func _in_radius(area):
	var parea = area.get_parent()
	if parea.is_in_group("player"):
		if parea.get_parent().faction != get_parent().faction:
			value.append(parea.get_parent())
	if parea.is_in_group("unit"):
		if parea.faction != get_parent().faction:
			value.append(parea)

func _out_radius(area):
	var parea = area.get_parent()
	value.remove(value.find(parea))

func _on_die():#When the player dies explode
	for dead in value:
		if(weakref(dead).get_ref()):
			weakref(dead).get_ref().die()

func _ready():
	get_parent().gun_multiplier -= deduct
	get_node("bomb").connect("area_entered",self,"_in_radius")
	get_node("bomb").connect("area_exited",self,"_out_radius")
	connect("tree_exited",self,"_on_die")
