extends GridContainer
export var playern = 0

func display_inv(list,type,nodereturn,thingnum = 0):
	get_tree().call_group("match_lobby","i_spawn_inventory",list,type,playern,nodereturn,thingnum)

func set_nickname(color):
	var nicktext = get_node("mecha/info/nickname").text
	get_tree().call_group("match_lobby","i_set_nickname",playern,nicktext,color)

func _ready():
	var invres = load("res://scripts/inventoryres.gd")

	get_node("mecha/info/mechacolor").connect("color_changed",self,"set_nickname")

	get_node("mecha/mecha_custom/mechtype").connect("pressed",self,"display_inv",[invres.get_mechas(),'mecha',get_node("mecha/mecha_custom/mechtype")])
	get_node("mecha/mecha_custom/decoyslot").connect("pressed",self,"display_inv",[invres.get_decoys(),'decoy',get_node("mecha/mecha_custom/decoyslot")])

	var thingnum = 0#First the units
	for i in get_node("mecha/units").get_children():
		if(i.is_class("Button")):
			i.connect("pressed",self,"display_inv",[invres.get_units(),'unit',i])
			thingnum += 1
	thingnum = 0#Now the parts
	for j in get_node("mecha/mecha_custom/parts").get_children():
		if(j.is_class("Button")):
			j.connect("pressed",self,"display_inv",[invres.get_parts(),'part',j])
			thingnum += 1
	thingnum = 0#Finally the weapons
	for k in get_node("mecha/mecha_custom/weapons").get_children():
		if(k.is_class("Button")):
			k.connect("pressed",self,"display_inv",[invres.get_weapons(),'weapon',k])
			thingnum += 1
	
	get_node("mecha/player_dat/plnum").set_text("Player "+str(playern+1))