extends Control
###The node of much information. I see dot I KNOW DOT!
var trackingn = 0
var gname = "player_ui"

##Unit management
func purchase_unit(unit,pnum,new_wallet = 0,unitname = "Unknown"):#This is mainly used to send info to the HUD about the unit's status, this could be done easier with get_tree.call_group("Whatever the new name would be")
	get_node("progress/wallet").set_text("$: "+str(new_wallet))
	var qline = get_node("queue_line")
	var qtag = load("res://ui/queuetag.tscn").instance()
	qtag.playern = pnum
	qtag.unitname = unitname
	qtag.unit = unit[0]
	qtag.queuetime = unit[1]
	qline.add_child(qtag)

func set_player_wallet(value):#Another hud element, this time pertaining to the monitoring of the player's money
	get_node("progress/wallet").set_text("$: "+str(value))

func set_player_resources(value):#Sets the monitoring number of resources for Oil, Gold, ETC.
	var shop = get_node("shop")
	shop.set_resources(value)

func remove_qtag():#Removes a queuetag , Note this currently has a bug with it selecting tags that are not done yet.
	var qline = get_node("queue_line")
	qline.get_child(0).queue_free()

#Inventory
func add_inv(unittext):#Adds a unit to the inventory display
	var lb = Label.new()
	lb.text = unittext
	get_node("progress/pl_inv").add_child(lb)

func remove_inv(unit):#Removes a unit from the inventory display
	var pl_inv = get_node("progress/pl_inv")
	if(pl_inv.get_children().size() > 0):
		pl_inv.get_child(0).queue_free()

##UI
func set_player_health(int_health):
	var progress = get_node("progress")
	var health = progress.get_node("health")
	health.set_value(int_health)

func set_player_rate(node_bar,int_rate):#Enables a player's hud
	var progress = get_node("progress")
	if(progress.has_node(node_bar)):
		var uirate = progress.get_node(node_bar)
		uirate.set_value(int_rate)

func display_hint(value):#Display a hint, like the buy menu or command list 
	get_node("display").set_text(value)

func toggle_shop():
	var shop = get_node("shop")
	if(!shop.visible):
		shop.visible = true
		Input.set_mouse_mode(Input.MOUSE_MODE_VISIBLE)
	else:
		shop.visible = false
		Input.set_mouse_mode(Input.MOUSE_MODE_CAPTURED)
	print("player ui.gd: toggle shop ",trackingn,shop.visible)

##Respawn
func set_counter(life_count):#Sets the lives counter
	var life_counter = get_node("lives/number")
	life_counter.set_text(str(life_count))

## MAIN
func _ready():
	add_to_group(gname+str(trackingn))
	