extends Position3D
###An object used for DM, Invincible spawn
#Description
var gname = "spawn"
export var faction = 0
export(Color) var skin = Color("909090") 

##Spawning
func spawn_new(pnode,playerdata,trackingn,is_respawn = false,stat_lives = 3):#Spawn player at it's own location
	var new_player = load(playerdata["player_res"]).instance()
	new_player.input_script = playerdata["input_con"]
	if(playerdata["input_con"] == "res://scripts/player.gd"):
		get_tree().call_group(str(playerdata["playern"])+"vcon","set_camsock",new_player.get_node("camsocket"))
	if(get_tree().network_peer != null):#If it's an online match determine who owns the mecha
		new_player.set_network_master(playerdata["id"])

#set up new_player
	new_player.trackingn = trackingn
	new_player.spawn_point = pnode
	new_player.lives = stat_lives
	new_player.is_respawning = is_respawn#This is for resetting the vcom
	new_player.playern = playerdata["playern"]
	new_player.skin = skin
	new_player.faction = playerdata["p_faction"]
	new_player.nickname = playerdata["nickname"]

#unit
	new_player.unit_list = playerdata["units_res"]
#parts
	new_player.parts = playerdata["parts_res"]
#weapons
	new_player.gun = playerdata["weapons_res"]
	new_player.decoyammo = playerdata["decoy_res"][0]
	new_player.decoy_timer = playerdata["decoy_res"][1]
	new_player.dt_limit = playerdata["decoy_res"][1]

#Create a random spot for it
	randomize()
	var vectrand = Vector3(rand_range(-5,5),0,rand_range(-5,5))
	new_player.translation = vectrand

	pnode.add_child(new_player)

##Prep
func detect_game_mode():#Sets the spawn to the level's gamemode, Should be called by level.gd
	if(has_node("/root/level")):
		var level = get_node("/root/level")
		match(level.game_mode):
			(level.game_modes.DM):#By default spawn is DM
				pass
			(level.game_modes.DB):
				var hq = load("res://objects/elements/headquarters.tscn").instance()
				hq.translation = Vector3(0,-2,0)
				add_child(hq)
			(level.game_modes.ST):
				pass
	if(has_node("headquarters")):#Make sure the headquarter's handle's player's with money
		var hq = get_node("headquarters")
		hq.faction = faction
		hq.set_base_color(skin)

##MAIN
func _ready():
	add_to_group(gname)#This is used for level when it's switched modes.
	add_to_group(gname+str(faction))#This is for individual call ins to the specific spawn point